#!/bin/bash
apt update

#Install HAproxy
apt install -y curl git haproxy 

#Clone PLED repoistory
git clone https://github.com/amojamo/PLED /home/ubuntu/pled

#Stop HAproxy sevice
service haproxy stop

#Install Apache
apt install -y apache2

#Generate self-signed certificate with Apache
a2enmod ssl
service restart apache2
openssl req -x509 -nodes -days 500 -newkey rsa:2048 -keyout /tmp/dfapi.key -out /tmp/dfapi.crt -subj "/C=NO/ST=Self/L=Self/O=Self/OU=Self/CN=Self"
openssl req -x509 -nodes -days 500 -newkey rsa:2048 -keyout /tmp/dbwebintf.key -out /tmp/dbwebintf.crt -subj "/C=NO/ST=Self/L=Self/O=Self/OU=Self/CN=Self"
cat /tmp/dbwebintf.crt /tmp/dbwebintf.key > /etc/ssl/private/dbweb-intf.pem 
cat /tmp/dfapi.crt /tmp/dfapi.key > /etc/ssl/private/dfapi.pem 
chmod 600 /etc/ssl/private/dfapi.pem 
chmod 600 /etc/ssl/private/dbweb-intf.pem

#Uninstall Apache
service apache2 stop

#Copy the HAproxy config
cp /home/ubuntu/pled/misc/haproxy.cfg /etc/haproxy/

#Insert approperiate IP to haproxy config
/bin/sed -i 's/DFAPIIP/df_ip_pub/g' /etc/haproxy/haproxy.cfg
/bin/sed -i 's/WEBINTERFACEIP/interface_ip_pub/g' /etc/haproxy/haproxy.cfg

service haproxy start