#!/bin/bash
apt update

#Installing Docker and Docker-Compose
curl -fsSL https://get.docker.com -o get-docker.sh
sh get-docker.sh
curl -L "https://github.com/docker/compose/releases/download/1.24.0/docker-compose-$(uname -s)-$(uname -m)" -o /usr/local/bin/docker-compose
chmod +x /usr/local/bin/docker-compose

#Clone PLED repository
git clone https://github.com/amojamo/PLED.git /home/ubuntu/pled

#Config for registry
cat <<EOF > /home/ubuntu/pled/docker/docker-registry/config.yml
version: 0.1
log:
  level: debug
  fields:
    service: registry
storage:
  cache:
    blobdescriptor: inmemory
  swift:
    username: swift_username
    password: swift_password
    authurl: https://api.skyhigh.iik.ntnu.no:5000/v3
    domain: swift_domain
    tenantid: swift_tenantid
    insecureskipverify: true
    region: SkyHiGh
    container: swift_container
http:
  addr: :5000
  headers:
    X-Content-Type-Options: [nosniff]
health:
  storagedriver:
    enabled: true
    interval: 10s
EOF

#Create basic credentials
mkdir -p /home/ubuntu/htpasswd_backup
chmod 777 /home/ubuntu/htpasswd_backup
docker run --rm --entrypoint htpasswd registry:2 -Bbn basicuname "basicpw" >/home/ubuntu/htpasswd_backup/htpasswd

#Start docker registry
docker-compose -f /home/ubuntu/pled/docker/docker-registry/docker-compose.yml -f /home/ubuntu/pled/docker/docker-registry/docker-compose.auth.yml up -d --build