#!/bin/bash
apt update
apt install -y curl git composer zip

#Installing Docker and Docker-Compose
curl -fsSL https://get.docker.com -o get-docker.sh
sh get-docker.sh
curl -L "https://github.com/docker/compose/releases/download/1.24.0/docker-compose-$(uname -s)-$(uname -m)" -o /usr/local/bin/docker-compose
chmod +x /usr/local/bin/docker-compose

#Clone PLED repository
git clone https://github.com/amojamo/PLED /home/ubuntu/pled

#Wait for cloning just in case
sleep 5

#Add environment for Composer and install dependencies with Composer
cd /home/ubuntu/pled/www && export COMPOSER_HOME="/home/ubuntu/pled/www" && composer install --ignore-platform-reqs

#Start DreamFactory with docker-compose
docker-compose -f /home/ubuntu/pled/docker/docker-compose-www.yml up -d && docker exec -t docker_www_1 chmod -R 777 /var/www/html/conf