#!/bin/bash
apt update

#Install HAproxy
apt install -y curl git mongodb-clients sshpass

#Clone PLED repoistory
git clone https://github.com/amojamo/PLED /home/ubuntu/pled

#Mount attached backup volume
mkdir /backup
mkfs -t ext4 /dev/vdb
mount -t ext4 /dev/vdb /backup
mkdir /backup/{dfbackup,mongodb_backup}

#Wait until other machines are ready
sleep 30

#Generate SSH-key for backup jobs
ssh-keygen -f /home/ubuntu/.ssh/bkup_key -N ''
chown ubuntu:ubuntu /home/ubuntu/.ssh/bkup_key*

#Copy SSH-key to relevant machines, as Ubuntu user
sudo -Hu ubuntu /usr/bin/sshpass -v -p pwd ssh-copy-id -i /home/ubuntu/.ssh/bkup_key.pub -o StrictHostKeyChecking=no backupbot@df_ip
sudo -Hu ubuntu /usr/bin/sshpass -v -p pwd ssh-copy-id -i /home/ubuntu/.ssh/bkup_key.pub -o StrictHostKeyChecking=no backupbot@db_ip

echo pwd > /home/ubuntu/passwordBackup.txt

crontab -l > /home/ubuntu/customcron

#Adding cronjob for backup of MongoDB
echo "1 0 * * * /usr/bin/mongodump --username root --password mongodbrootpw --authenticationDatabase admin --host db_ip --port 27017 --db pled --forceTableScan -o /backup/mongodb_backup/mongodb_\$(date +\%Y_\%m_\%d) --gzip" >> /home/ubuntu/customcron

#Syncronize DreamFactory backup folders from remote to local host
echo "10 0 * * * /usr/bin/rsync -a -e \"/usr/bin/ssh -i /home/ubuntu/.ssh/bkup_key -o StrictHostKeyChecking=no\" backupbot@df_ip:/home/backupbot/backup/dfbackup/ /backup/dfbackup/" >> /home/ubuntu/customcron

#Rotate DreamFactory backup older than 14 days
echo "20 0 * * * /usr/bin/find /backup/dfbackup/ -mtime +14 -type f -delete" >> /home/ubuntu/customcron

#Rotate MongoDB backup older than 14 days
echo "25 0 * * * /usr/bin/find /backup/mongodb_backup/ -mtime +14 -type f -delete" >> /home/ubuntu/customcron

crontab /home/ubuntu/customcron