#!/bin/bash
apt update
apt install -y curl git

#Add user for backupjobs and ready the account for incomming ssh-copy-id from manager
adduser backupbot --gecos "Backup Bot, , , " --disabled-password
echo "backupbot:pwd" | chpasswd
usermod -aG sudo backupbot
mkdir /home/backupbot/.ssh
chown -R backupbot:backupbot /home/backupbot/.ssh
chmod 700 /home/backupbot/.ssh

#Allow password login for SSH
/bin/sed -i 's/PasswordAuthentication no/PasswordAuthentication yes/' /etc/ssh/sshd_config
/bin/sed -i 's/ChallengeResponseAuthentication no/ChallengeResponseAuthentication yes/' /etc/ssh/sshd_config
service ssh restart

#Installing Docker and Docker-Compose
curl -fsSL https://get.docker.com -o get-docker.sh
sh get-docker.sh
curl -L "https://github.com/docker/compose/releases/download/1.24.0/docker-compose-$(uname -s)-$(uname -m)" -o /usr/local/bin/docker-compose
chmod +x /usr/local/bin/docker-compose

#Clone PLED repoistory
git clone https://github.com/amojamo/PLED /home/ubuntu/pled

#Mount attached data volume
mkdir /bitnami
mkfs -t ext4 /dev/vdb
mount -t ext4 /dev/vdb /bitnami

#Create backup folder for rsync
sudo -Hu backupbot mkdir -p /home/backupbot/backup/dfbackup

#Chwon folder in preparation for Bitnami Docker Image
sudo chown -R 1001:1001 /bitnami

#Create the needed volumes for Docker
docker volume create --driver local --opt type=ext4 --opt device=/dev/vdb dreamfactory_data 
docker volume create --driver local --opt type=ext4 --opt device=/dev/vdb redis_data
docker volume create --driver local --opt type=ext4 --opt device=/dev/vdb mariadb_data
docker volume create --driver local --opt type=ext4 --opt device=/dev/vdb mongodb_data

#Start DreamFactory with docker-compose
docker-compose -f /home/ubuntu/pled/docker/docker-compose-df.yml up -d

#Adding cronjob for backup of DreamFactory
crontab -l | { cat; echo "0 0 * * * /bin/bash /home/ubuntu/pled/misc/backup_dfvol.sh"; } | crontab -