#!/bin/bash
apt update
apt install -y curl git mongo-tools

#Add user for backupjobs and ready the account for incomming ssh-copy-id from manager
adduser backupbot --gecos "Backup Bot, , , " --disabled-password
echo "backupbot:pwd" | chpasswd
mkdir /home/backupbot/.ssh
ssh-keygen -f /home/backupbot/.ssh/id_rsa -N ''
chown backupbot:backupbot /home/backupbot/.ssh/id_rsa*
chown -R backupbot:backupbot /home/backupbot/.ssh
chmod 700 /home/backupbot/.ssh

#Allow password login for SSH
/bin/sed -i 's/PasswordAuthentication no/PasswordAuthentication yes/' /etc/ssh/sshd_config
/bin/sed -i 's/ChallengeResponseAuthentication no/ChallengeResponseAuthentication yes/' /etc/ssh/sshd_config
service ssh restart

#Installing Docker and Docker-Compose
curl -fsSL https://get.docker.com -o get-docker.sh
sh get-docker.sh
curl -L "https://github.com/docker/compose/releases/download/1.24.0/docker-compose-$(uname -s)-$(uname -m)" -o /usr/local/bin/docker-compose
chmod +x /usr/local/bin/docker-compose

#Clone PLED repository
git clone https://github.com/amojamo/PLED /home/ubuntu/pled

#Mount attached data volume
mkdir /bitnami
mkfs -t ext4 /dev/vdb
mount -t ext4 /dev/vdb /bitnami

#Chwon folder in preparation for Bitnami Docker Image
sudo chown -R 1001:1001 /bitnami

#Create the needed volumes for Docker
docker volume create --driver local --opt type=ext4 --opt device=/dev/vdb mongodb-master-data 

#Set password for MongoDB
/bin/sed -i 's/MONGODB_ROOT_PASSWORD=ROOT_PASSWORD/MONGODB_ROOT_PASSWORD=mongodbrootpw/' /home/ubuntu/pled/docker/docker-compose-mongorep.yml && \
/bin/sed -i 's/MONGODB_PRIMARY_ROOT_PASSWORD=ROOT_PASSWORD/MONGODB_PRIMARY_ROOT_PASSWORD=mongodbrootpw/g' /home/ubuntu/pled/docker/docker-compose-mongorep.yml && \
/bin/sed -i 's/MONGODB_REPLICA_SET_KEY=REPLICA_KEY/MONGODB_REPLICA_SET_KEY=mongodbreplicapw/' /home/ubuntu/pled/docker/docker-compose-mongorep.yml

#Start MongoDB with docker-compose
docker-compose -f /home/ubuntu/pled/docker/docker-compose-mongorep.yml up -d

#Add Crontab for vulnRetriever script if enabled

if [ vulnRetrieverUpdateMode = "True" ]; then
    echo "1 0 * * * cd /home/ubuntu/pled/vulnRetriever/ && /usr/bin/python3 /home/ubuntu/pled/vulnRetriever/vulnRetriever.py -u -l >>/home/ubuntu/.vuln.log 2>&1" >> /home/ubuntu/customcron
    crontab /home/ubuntu/customcron
fi


#Dump exploitdb applications into database
mongorestore --username root --password mongodbrootpw --authenticationDatabase admin --host localhost --port 27017 --collection vuln_applications --db pled /home/ubuntu/pled/misc/vuln_applications_edb.bson
RESULT=$?
while [ $RESULT -ne 0 ]
do	
	sleep 2
    mongorestore --username root --password mongodbrootpw --authenticationDatabase admin --host localhost --port 27017 --collection vuln_applications --db pled /home/ubuntu/pled/misc/vuln_applications_edb.bson
    RESULT=$?
done

#Start mongo express if specified
if [ mgoexpress = "True" ]; then
	docker run -d --network docker_default -e ME_CONFIG_MONGODB_SERVER=mongodb-primary -e ME_CONFIG_MONGODB_ADMINUSERNAME='root' -e ME_CONFIG_MONGODB_ADMINPASSWORD='mongodbrootpw' -e ME_CONFIG_BASICAUTH_USERNAME='basicuname' -e ME_CONFIG_BASICAUTH_PASSWORD='basicpw' -p 8088:8081 mongo-express &> /home/ubuntu/hei.txt
fi